﻿Public Class NewCalc
    Inherits System.Windows.Forms.Form
    Private Accum, Mem As String
    Private NumQueue As New Queue
    Private OpQueue As New Queue

    Private Sub op_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opplus.Click, opminus.Click, opmult.Click, opdivide.Click

        OpQueue.Enqueue(sender.tag) 'Loads the tag from the button that has been clicked into the OpQueue
        NumQueue.Enqueue(Accum) 'Loads the number from the screen into the NumQueue
        Accum = ""
    End Sub

    Private Sub opequals_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles opequals.Click
        Dim CurrentOp As String
        Dim Num1, Num2 As Double
        NumQueue.Enqueue(Accum)
        Try
            Num1 = CDbl(NumQueue.Dequeue) 'Loads the first Number in the queue into Num1 and clears it from the queue
            Num2 = CDbl(NumQueue.Dequeue) 'Loads the next Number in the queue into Num2 and clears it from the queue
            Do 'continue to loop until told to exit
                CurrentOp = OpQueue.Dequeue 'Loads the curtent operation in the queue into CurentOP and clears it from the queue
                Select Case CurrentOp 'selects which operation has been loaded
                    Case "Divide"
                        If Num2 <> 0 Then
                            Num1 /= CDbl(Num2) 'do the calculation and store it in Num1
                        Else
                            CalcPadDisplay.Text = "Divide By Zero"
                            Exit Sub
                        End If
                    Case "Multiply"
                        Num1 *= CDbl(Num2) 'do the calculation and store it in Num1
                    Case "Add"
                        Num1 += CDbl(Num2) 'do the calculation and store it in Num1
                    Case "Subtract"
                        Num1 -= CDbl(Num2) 'do the calculation and store it in Num1
                End Select
                If NumQueue.Count = 0 Then Exit Do 'if the numbers have all been dealt with stop looping
                Num2 = NumQueue.Dequeue 'otherwise load the next number and clear it from the queue
            Loop
            CalcPadDisplay.Text = CStr(Num1) 'display the result
            Accum = ""
        Catch
            OpQueue.Clear()
            NumQueue.Clear()
            Accum = ""
            CalcPadDisplay.Text = "0"
            Exit Sub
        End Try
    End Sub

    Private Sub keyClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles key1.Click, key2.Click, key3.Click, key4.Click, key5.Click, key6.Click, key7.Click, key8.Click, key9.Click, key0.Click, keydecimal.Click
        If Len(Accum) = 0 Then
            ' First keypress
            Accum = sender.tag
        Else
            ' Second or later keypress
            Accum &= sender.tag
        End If
        CalcPadDisplay.Text = Accum
    End Sub

    Private Sub opclear_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles opclear.Click, opclearentry.Click
        CalcPadDisplay.Text = "0"
        Accum = ""
        If sender.tag = "Clear" Then
            OpQueue.Clear()
            NumQueue.Clear()
        End If

    End Sub

    Private Sub Memory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Memory.Click
        Dim CurrentTag As String = Memory.Tag
        Select Case CurrentTag
            Case "MemIn"
                Mem = CalcPadDisplay.Text
                NumQueue.Clear()
                Accum = ""
                CalcPadDisplay.Clear()
                Memory.Tag = "MemOut"
                Memory.Text = "M -"
            Case "MemOut"
                CalcPadDisplay.Text = Mem
                Accum = Mem
                Memory.Tag = "MemIn"
                Memory.Text = "M +"
        End Select
    End Sub
End Class

